################################################################################
# deploy stage jobs
################################################################################

pages:
  stage: deploy
  script:
    - echo "Pages accessible through https://docs.gitlab.com/${PAGES_PREFIX}/"
  needs:
    - build:compile_site
  pages:
    path_prefix: ${PAGES_PREFIX}
    expire_in: never
  environment:
    name: $ENVIRONMENT_NAME
    url: https://docs.gitlab.com/${PAGES_PREFIX}
  artifacts:
    paths:
      - public
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event" && $CI_MERGE_REQUEST_EVENT_TYPE == "merge_train"'
      when: never
    - if: '$DOCS_PROJECT_PIPELINE_TYPE == "Stable branch pipeline"'
      when: never
    - if: '$DOCS_PROJECT_PIPELINE_TYPE =~ /^MR pipeline.*/'
      variables:
        ENVIRONMENT_NAME: 'review/mr-${CI_MERGE_REQUEST_IID}'
        PAGES_PREFIX: 'review-mr-${CI_MERGE_REQUEST_IID}'
    - if: '$DOCS_PROJECT_PIPELINE_TYPE == "Upstream review app pipeline"'
      variables:
        ENVIRONMENT_NAME: 'upstream-review/mr-${REVIEW_SLUG}'
        PAGES_PREFIX: 'upstream-review-mr-${REVIEW_SLUG}'
    - if: '$DOCS_PROJECT_PIPELINE_TYPE == "Default branch pipeline"'
      variables:
        ENVIRONMENT_NAME: 'production'
        PAGES_PREFIX: ''

pages-archives:
  stage: deploy
  needs:
    - build:compile_archive
  script:
    # We need to move the contents of public/${CI_COMMIT_REF_NAME}/ under
    # public/, otherwise the version will be deployed under /<version>/<version>.
    - mv public dest
    - mv dest/${CI_COMMIT_REF_NAME} public
    - echo "Archive deployed to https://docs.gitlab.com/${CI_COMMIT_REF_NAME}/"
  environment:
    name: archives/${CI_COMMIT_REF_NAME}
    url: https://docs.gitlab.com/${CI_COMMIT_REF_NAME}
  pages:
    path_prefix: ${CI_COMMIT_REF_NAME}
    expire_in: never
  artifacts:
    paths:
      - public
  rules:
    - if: '$DOCS_PROJECT_PIPELINE_TYPE == "Stable branch pipeline"'
